diff -uNrd -x CVS ircd-hybrid-7rc5/include/numeric.h ircd-hybrid-7-bg/include/numeric.h
--- ircd-hybrid-7rc5/include/numeric.h	Tue Oct 29 22:33:22 2002
+++ ircd-hybrid-7-bg/include/numeric.h	Sat May 24 23:27:09 2003
@@ -19,19 +19,20 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: numeric.h,v 7.30 2002/10/30 03:33:22 bill Exp $
+ *  $Id: numeric.h,v 1.5 2003/05/24 00:07:44 demond Exp $
  */
 
 #ifndef INCLUDED_numeric_h
 #define INCLUDED_numeric_h
 
 #include "config.h"
+#include "client.h"
 
 /*
  * form_str - return a format string for a message number
  * messages are defined below
  */
-extern const char* form_str(int);
+extern char* form_str(struct Client *, int);
 
 /*
  * Reserve numerics 000-099 for server-client connections where the client
@@ -43,23 +44,20 @@
 #define RPL_CREATED          003
 #define RPL_MYINFO           004
 #define RPL_ISUPPORT         005
-     /* RPL_BOUNCE                         IRCnet extension */
-/*	RPL_MAP		       6	unreal */
-/*	RPL_MAPEND	       7	unreal */
-/*	RPL_SNOMASK            8        Undernet extension */
-/*	RPL_STATMEMTOT         9        Undernet extension */
-/*	RPL_STATMEM           10        Undernet extension */
-
-#define RPL_REDIR            10
-#define RPL_MAP		     15		/* Undernet extension */
-#define RPL_MAPMORE	     16		/* Undernet extension */
-#define RPL_MAPEND	     17		/* Undernet extension */
-#define RPL_YOURID           20
-
-/*	RPL_YOURID	      42	IRCnet extension */
-/*      RPL_ATTEMPTINGJUNC    50           aircd extension */
-/*      RPL_ATTEMPTINGREROUTE 51           aircd extension */
-
+/*	RPL_BOUNCE								IRCnet extension */
+/*	RPL_MAP		       		6				unreal */
+/*	RPL_MAPEND	       		7				unreal */
+/*	RPL_SNOMASK            	8        		Undernet extension */
+/*	RPL_STATMEMTOT         	9        		Undernet extension */
+/*	RPL_STATMEM           	10        		Undernet extension */
+#define RPL_REDIR           10
+#define RPL_MAP		     	15				/* Undernet extension */
+#define RPL_MAPMORE	     	16				/* Undernet extension */
+#define RPL_MAPEND	     	17				/* Undernet extension */
+#define RPL_YOURID          20
+/*	RPL_YOURID	      		42				IRCnet extension */
+/*  RPL_ATTEMPTINGJUNC    	50           	aircd extension */
+/*  RPL_ATTEMPTINGREROUTE 	51           	aircd extension */
 /*
  * Numeric replies from server commands.
  * These are currently in the range 200-399.
@@ -73,16 +71,14 @@
 #define RPL_TRACESERVER      206
 #define RPL_TRACENEWTYPE     208
 #define RPL_TRACECLASS       209
-
 /*      RPL_STATS            210 aircd extension, used instead of having
                                  multiple stats numerics */
 /*      RPL_TRACERECONNECT   210 IRCnet extension */                                 
-
 #define RPL_STATSLINKINFO    211
 #define RPL_STATSCOMMANDS    212
 #define RPL_STATSCLINE       213
 #define RPL_STATSNLINE       214
-/*	RPL_STATSOLDNLINE    214    unreal */
+/*	RPL_STATSOLDNLINE    	214    unreal */
 #define RPL_STATSILINE       215
 #define RPL_STATSKLINE       216
 #define RPL_STATSQLINE       217
@@ -93,36 +89,34 @@
  * I'm going to steal 220 for now *sigh*
  * -Dianora
  */
-
 #define RPL_STATSPLINE       220
 #define RPL_UMODEIS          221
-
 /*	RPL_SQLINE_NICK	     222	   Numerics List: Dalnet */
 /*	RPL_STATSELINE       223	   dalnet */
 /*	RPL_STATSGLINE	     223	   unreal */
-/*      RPL_STATSFLINE       224           Hybrid extension,Dalnet */
+/*  RPL_STATSFLINE       224       Hybrid extension,Dalnet */
 /*	RPL_STATSTLINE	     224	   unreal */
-/*      RPL_STATSDLINE       225           Hybrid extension */
+/*  RPL_STATSDLINE       225       Hybrid extension */
 /*	RPL_STATSZLINE	     225	   Dalnet
  	RPL_STATSELINE	     225	   unreal
  	RPL_STATSCOUNT	     226	   Dalnet
 	RPL_STATSNLINE	     226	   unreal
 	RPL_STATSGLINE	     227	   Dalnet 
 	RPL_STATSVLINE	     227	   unreal */
-
 #define RPL_STATSFLINE       224
 #define RPL_STATSDLINE       225
 #define RPL_STATSALINE	     226
-
-/*	RPL_RULES	     232	unreal */
-
+#define RPL_STATSZLINE	     227 /* configured services line */
+#define RPL_EQUIVALENTS      228 /* configured equivalent nicks */
+#define RPL_RELAYS           229 /* configured relays (bnet ext) */
+#define RPL_USERPARMS        230 /* configured recognizable USER pars */
+#define RPL_CLUSTERBRIDGE    231 /* configured cluster bridges */
+/*	RPL_RULES	     		232		unreal */
 #define RPL_SERVLIST         234
 #define RPL_SERVLISTEND      235
-
-/*      RPL_STATSIAUTH       239           IRCnet extension */
-/*      RPL_STATSVLINE       240           IRCnet extension */
-/*	RPL_STATSXLINE	     240	austnet */
-
+/*  RPL_STATSIAUTH       	239		IRCnet extension */
+/*  RPL_STATSVLINE       	240		IRCnet extension */
+/*	RPL_STATSXLINE	     	240		austnet */
 #define RPL_STATSLLINE       241
 #define RPL_STATSUPTIME      242
 #define RPL_STATSOLINE       243
@@ -133,7 +127,7 @@
 #define RPL_STATSULINE       248
 #define RPL_STATSDEBUG       249
 #define RPL_STATSCONN        250
-/*	RPL_STATSDLINE	     250	   Numerics List: IRCnet */
+/*	RPL_STATSDLINE	     	250	   	Numerics List: IRCnet */
 #define RPL_LUSERCLIENT      251
 #define RPL_LUSEROP          252
 #define RPL_LUSERUNKNOWN     253
@@ -143,57 +137,51 @@
 #define RPL_ADMINLOC1        257
 #define RPL_ADMINLOC2        258
 #define RPL_ADMINEMAIL       259
-
 #define RPL_TRACELOG         261
 #define RPL_ENDOFTRACE       262
 #define RPL_LOAD2HI          263
-
-/*	RPL_TRYAGAIN	     263	   Numerics List: IRCnet */
-/*	RPL_LOAD2HI	     263	   Dalnet */
-/*      RPL_CURRENT_LOCAL    265           aircd/efnet/hybrid/dalnet*/
-/*      RPL_CURRENT_GLOBAL   266           aircd/efnet/hybrid/dalnet */
-/*      RPL_START_NETSTAT    267           aircd */
-/*      RPL_NETSTAT          268           aircd */
-/*      RPL_END_NETSTAT      269           aircd */
-
+/*	RPL_TRYAGAIN	     	263	   	Numerics List: IRCnet */
+/*	RPL_LOAD2HI	     		263	   	Dalnet */
+/*  RPL_CURRENT_LOCAL    	265		aircd/efnet/hybrid/dalnet*/
+/*  RPL_CURRENT_GLOBAL   	266		aircd/efnet/hybrid/dalnet */
+/*  RPL_START_NETSTAT    	267		aircd */
+/*  RPL_NETSTAT          	268		aircd */
+/*  RPL_END_NETSTAT      	269		aircd */
 #define RPL_LOCALUSERS       265
 #define RPL_GLOBALUSERS      266
-
+#define RPL_IDUSERS          267
 #define RPL_VCHANEXIST       276
 #define RPL_VCHANLIST        277
 #define RPL_VCHANHELP        278
-
 #define RPL_ACCEPTLIST	     281
 #define RPL_ENDOFACCEPT      282
-
-/*	RPL_GLIST            280        Undernet extension */
-/*	RPL_ENDOFGLIST       281        Undernet extension */
-/*	RPL_JUPELIST         282        Undernet extension - jupe -Kev */
-/*	RPL_ENDOFJUPELIST    283        Undernet extension - jupe -Kev */
-/*	RPL_FEATURE	     284	Undernet extension - features */
-/*      RPL_CHANINFO_HANDLE  285           aircd */
-/*      RPL_CHANINFO_USERS   286           aircd */
-/*      RPL_CHANINFO_CHOPS   287           aircd */
-/*      RPL_CHANINFO_VOICES  288           aircd */
-/*      RPL_CHANINFO_AWAY    289           aircd */
-/*      RPL_CHANINFO_OPERS   290           aircd */
-/*	RPL_HELPHDR	     290	Numeric List: Dalnet */
-/*      RPL_CHANINFO_BANNED  291           aircd */
-/*	RPL_HELPOP	     291	Numeric List: Dalnet */
-/*      RPL_CHANINFO_BANS    292           aircd */
-/*	RPL_HELPTLR	     292	Numeric List: Dalnet */
-/*      RPL_CHANINFO_INVITE  293           aircd */
-/*	RPL_HELPHLP	     293	Numeric List: Dalnet */
-/*      RPL_CHANINFO_INVITES 294           aircd */
-/*	RPL_HELPFWD	     294	Numeric List: Dalnet */
-/*      RPL_CHANINFO_KICK    295           aircd */
-/*	RPL_HELPIGN	     295	Numeric List: Dalnet */
-/*      RPL_CHANINFO_KICKS   296           aircd */
-
-/*      RPL_END_CHANINFO     299           aircd */
-
+/*	RPL_GLIST            	280        Undernet extension */
+/*	RPL_ENDOFGLIST       	281        Undernet extension */
+/*	RPL_JUPELIST         	282        Undernet extension - jupe -Kev */
+/*	RPL_ENDOFJUPELIST    	283        Undernet extension - jupe -Kev */
+/*	RPL_FEATURE	     		284			Undernet extension - features */
+/*  RPL_CHANINFO_HANDLE  	285           aircd */
+/*  RPL_CHANINFO_USERS   	286           aircd */
+/*  RPL_CHANINFO_CHOPS   	287           aircd */
+/*  RPL_CHANINFO_VOICES  	288           aircd */
+/*  RPL_CHANINFO_AWAY    	289           aircd */
+/*  RPL_CHANINFO_OPERS   	290           aircd */
+/*	RPL_HELPHDR	     		290			Numeric List: Dalnet */
+/*  RPL_CHANINFO_BANNED  	291           aircd */
+/*	RPL_HELPOP	     		291			Numeric List: Dalnet */
+/*  RPL_CHANINFO_BANS    	292           aircd */
+/*	RPL_HELPTLR	     		292			Numeric List: Dalnet */
+/*  RPL_CHANINFO_INVITE  	293           aircd */
+/*	RPL_HELPHLP	     		293			Numeric List: Dalnet */
+/*  RPL_CHANINFO_INVITES 	294           aircd */
+/*	RPL_HELPFWD	     		294			Numeric List: Dalnet */
+/*  RPL_CHANINFO_KICK    	295           aircd */
+/*	RPL_HELPIGN	     		295			Numeric List: Dalnet */
+/*  RPL_CHANINFO_KICKS   	296           aircd */
+/*  RPL_END_CHANINFO     	299           aircd */
 /* numeric_replies */
-
+#define	RPL_WHOISSSL		 297 /* uses SSL */
+#define RPL_WHOISCYRILLIC    298 /* this nick is cyrillic-encoded */
 #define RPL_NONE             300
 #define RPL_AWAY             301
 #define RPL_USERHOST         302
@@ -201,31 +189,28 @@
 #define RPL_TEXT             304
 #define RPL_UNAWAY           305
 #define RPL_NOWAWAY          306
-#define	RPL_USERIP	     307	/* Undernet extension */
+#define	RPL_USERIP	         307 /* Undernet extension */
 /*	RPL_WHOISREGNICK     307 	Numeric List: Dalnet */
 /*	RPL_SUSERHOST	     307	austnet */
-/*      RPL_NOTIFYACTION     308         aircd */
+/*  RPL_NOTIFYACTION     308    aircd */
 /*	RPL_WHOISADMIN	     308	Numeric List: Dalnet */
 /*	RPL_RULESSTART	     308	unreal */
-/*      RPL_NICKTRACE        309         aircd */
+#define RPL_WHOISADMIN       308
+/*  RPL_NICKTRACE        309    aircd */
 /*	RPL_WHOISSADMIN	     309	Numeric List: Dalnet */
 /*	RPL_ENDOFRULES	     309	unreal */
 /*	RPL_WHOISHELPER	     309	austnet */
-/*      RPL_WHOISSVCMSG      310         Dalnet */
+/*  RPL_WHOISSVCMSG      310    Dalnet */
 /*	RPL_WHOISHELPOP	     310	unreal */
 /*	RPL_WHOISSERVICE     310	austnet */
-
 #define RPL_WHOISUSER        311
 #define RPL_WHOISSERVER      312
 #define RPL_WHOISOPERATOR    313
-
 #define RPL_WHOWASUSER       314
 /* rpl_endofwho below (315) */
 #define RPL_ENDOFWHOWAS      369
-
 #define RPL_WHOISCHANOP      316 /* redundant and not needed but reserved */
 #define RPL_WHOISIDLE        317
-
 #define RPL_ENDOFWHOIS       318
 #define RPL_WHOISCHANNELS    319
 /*      RPL_WHOIS_HIDDEN     320         Anothernet +h, ick! */
@@ -234,6 +219,8 @@
 #define RPL_LIST             322
 #define RPL_LISTEND          323
 #define RPL_CHANNELMODEIS    324
+#define RPL_WHOISSVSHINT     326 /* identified with services */
+#define RPL_WHOISREALHOST    327 /* real client host */
 /*      RPL_CHANNELPASSIS    325           IRCnet extension */
 /*      RPL_UNIQOPIS         325           IRCnet extension */
 /*      RPL_NOCHANPASS       326           IRCnet extension */
@@ -246,26 +233,24 @@
 #define RPL_TOPICWHOTIME     333
 /*	RPL_COMMANDSYNTAX    334	   Dalnet */
 /*	RPL_LISTSYNTAX	     334	   unreal */
-/*      RPL_CHANPASSOK       338           IRCnet extension (?)*/
+/*  RPL_CHANPASSOK       338       IRCnet extension (?)*/
 #define	RPL_WHOISACTUALLY    338	/* dalnet */
 /*	RPL_WHOISACTUALLY    338	   Undernet extension, dalnet */
-/*      RPL_BADCHANPASS      339           IRCnet extension (?)*/
-/*	RPL_USERIP           340           (old) Undernet extension */
+/*  RPL_BADCHANPASS      339       IRCnet extension (?)*/
+/*	RPL_USERIP           340       (old) Undernet extension */
 #define RPL_INVITING         341
 /*	RPL_SUMMONING        342	   removed from RFC1459 */
-
+#define RPL_SUBSTLIST		 344 /* word subst list */
+#define RPL_ENDOFSUBSTLIST   345 /* eol */
 #define RPL_INVITELIST       346
 #define RPL_ENDOFINVITELIST  347	/* IRCnet, Undernet extension */
 #define RPL_EXCEPTLIST       348
 #define RPL_ENDOFEXCEPTLIST  349
-
 #define RPL_VERSION          351
-
 #define RPL_WHOREPLY         352
 #define RPL_ENDOFWHO         315
 #define RPL_NAMREPLY         353
 #define RPL_ENDOFNAMES       366
-
 #define RPL_KILLDONE         361
 #define RPL_CLOSING          362
 #define RPL_CLOSEEND         363
@@ -275,38 +260,34 @@
 #define RPL_BANLIST          367
 #define RPL_ENDOFBANLIST     368
 /* rpl_endofwhowas above (369) */
-
 #define RPL_INFO             371
 #define RPL_MOTD             372
 #define RPL_INFOSTART        373
 #define RPL_ENDOFINFO        374
 #define RPL_MOTDSTART        375
 #define RPL_ENDOFMOTD        376
-
+#define RPL_DENYLIST         377
+#define RPL_ENDOFDENYLIST    378
 /*      RPL_KICKEXPIRED      377   aircd */
-/*	RPL_SPAM	     377   austnet */
+/*		RPL_SPAM	     	 377   austnet */
 /*      RPL_BANEXPIRED       378   aircd */
 /*      RPL_KICKLINKED       379   aircd */
 /*      RPL_BANLINKED        380   aircd */
-
 #define RPL_YOUREOPER        381
 #define RPL_REHASHING        382
-/*	RPL_YOURSERVICE	     383	   Numeric List: various */
+/*	RPL_YOURSERVICE	    383	   		Numeric List: various */
 #define RPL_MYPORTIS         384
 #define RPL_NOTOPERANYMORE   385
 #define RPL_RSACHALLENGE     386
-
-/*	RPL_QLIST	     386	unreal */
-/*	RPL_ENDOFQLIST	     387	unreal */
-/*	RPL_ALIST	     388	unreal */
-/*	RPL_ENDOFALIST	     389	unreal */ 
-
+/*	RPL_QLIST	     	386			unreal */
+/*	RPL_ENDOFQLIST	    387			unreal */
+/*	RPL_ALIST	     	388			unreal */
+/*	RPL_ENDOFALIST	    389			unreal */ 
 #define RPL_TIME             391
 #define RPL_USERSSTART       392
 #define RPL_USERS            393
 #define RPL_ENDOFUSERS       394
 #define RPL_NOUSERS          395
-
 /*
  * Errors are in the range from 400-599 currently and are grouped by what
  * commands they come from.
@@ -319,55 +300,43 @@
 #define ERR_WASNOSUCHNICK    406
 #define ERR_TOOMANYTARGETS   407
 #define ERR_NOORIGIN         409
-
 #define ERR_NORECIPIENT      411
 #define ERR_NOTEXTTOSEND     412
 #define ERR_NOTOPLEVEL       413
 #define ERR_WILDTOPLEVEL     414
-/*	ERR_BADMASK          415           IRCnet extension */
+/*	ERR_BADMASK          	415		IRCnet extension */
 #define ERR_UNKNOWNCOMMAND   421
 #define ERR_NOMOTD           422
 #define ERR_NOADMININFO      423
 #define ERR_FILEERROR        424
-
-/* 	ERR_TOOMANYAWAY	     429	    Dalnet */
-
+/* 	ERR_TOOMANYAWAY	     	429	    Dalnet */
 #define ERR_NONICKNAMEGIVEN  431
 #define ERR_ERRONEUSNICKNAME 432
 #define ERR_NICKNAMEINUSE    433
-
-/*      ERR_SERVICENAMEINUSE 434 ? */
-/*	ERR_NORULES	     434   unreal */
-/*      ERR_SERVICECONFUSED  435 ? */
-/*	ERR_BANONCHAN	     435   dalnet */
-
+/*  ERR_SERVICENAMEINUSE 	434 	? */
+/*	ERR_NORULES	     		434   	unreal */
+/*  ERR_SERVICECONFUSED  	435 	? */
+/*	ERR_BANONCHAN	     	435   	dalnet */
 #define ERR_NICKCOLLISION    436
 #define ERR_UNAVAILRESOURCE  437
 #define ERR_NICKTOOFAST	     438	/* We did it first Undernet! ;) db */
-
-/*	ERR_SERVICESDOWN     440	Dalnet,unreal */
-
+/*	ERR_SERVICESDOWN     	440		Dalnet,unreal */
 #define ERR_USERNOTINCHANNEL 441
 #define ERR_NOTONCHANNEL     442
 #define ERR_USERONCHANNEL    443
 #define ERR_NOLOGIN          444
 #define ERR_SUMMONDISABLED   445
 #define ERR_USERSDISABLED    446
-
 #define ERR_NOTREGISTERED    451
-
-/*      ERR_IDCOLLISION      452           IRCnet extension ? */
-/*      ERR_NICKLOST         453           IRCnet extension ? */
-
-/*	ERR_HOSTILENAME	     455	   unreal */
-
-/*	ERR_NOHIDING	     459	   unreal */
-/*	ERR_NOTFORHALFOPS    460	   unreal */
-
+#define ERR_NOREPEATING      452 /* no repeating allowed */
+/*  ERR_IDCOLLISION      452           IRCnet extension ? */
+/*  ERR_NICKLOST         453           IRCnet extension ? */
+/*	ERR_HOSTILENAME	     455	   		unreal */
+/*	ERR_NOHIDING	     459	   		unreal */
+/*	ERR_NOTFORHALFOPS    460	   		unreal */
 #define ERR_ACCEPTFULL       456
 #define ERR_ACCEPTEXIST      457
 #define ERR_ACCEPTNOT        458
-
 #define ERR_NEEDMOREPARAMS   461
 #define ERR_ALREADYREGISTRED 462
 #define ERR_NOPERMFORHOST    463
@@ -375,10 +344,13 @@
 #define ERR_YOUREBANNEDCREEP 465
 #define ERR_YOUWILLBEBANNED  466
 #define ERR_KEYSET           467
+#define ERR_CANNOTSENDNOTREG 468	/* only reg nicks may speak */
+#define ERR_REGNICKSCHAN     469    /* channel is for reg nicks only */
+#define ERR_NOCYRNICKCHAN    470    /* no cyrillic nicks allowed */ 
 /* 	ERR_ONLYSERVERSCANCHANGE 468	   Dalnet,unreal */
-/*	ERR_LINKSET	     469	unreal */
-/*	ERR_LINKCHANNEL	     470	unreal */
-/*      ERR_KICKEDFROMCHAN   470         aircd */
+/*	ERR_LINKSET	     		469			unreal */
+/*	ERR_LINKCHANNEL	     	470			unreal */
+/*  ERR_KICKEDFROMCHAN   	470         aircd */
 #define ERR_CHANNELISFULL    471
 #define ERR_UNKNOWNMODE      472
 #define ERR_INVITEONLYCHAN   473
@@ -388,63 +360,61 @@
 #define ERR_MODELESS         477        /* ircu numeric -db */
 #define ERR_BANLISTFULL      478        /* I stole the numeric from ircu -db */
 #define ERR_BADCHANNAME      479
-/* 	ERR_LINKFAIL	     479	unreal */
-/*	ERR_CANNOTKNOCK	     480	unreal */
-/*	ERR_NOULINE	     480	austnet */
+#define ERR_SSLONLYCHAN      480	/* SSL-connected clients only channel */
+/* 	ERR_LINKFAIL	     	479			unreal */
+/*	ERR_CANNOTKNOCK	     	480			unreal */
+/*	ERR_NOULINE	     		480			austnet */
 #define ERR_NOPRIVILEGES     481
 #define ERR_CHANOPRIVSNEEDED 482
 #define ERR_CANTKILLSERVER   483
 #define ERR_RESTRICTED       484
 #define ERR_BANNEDNICK       485
-/*	ERR_DESYNC	     484	 Dalnet,PTlink */
-/*	ERR_ATTACKDENY	     484	 unreal */
-/*	ERR_RESTRICTED	     484	   IRCnet extension */
-/*      ERR_UNIQOPRIVSNEEDED 485           IRCnet extension */
-/*	ERR_KILLDENY         485	   unreal */
-/*	ERR_CANTKICKADMIN    485	   PTlink */
-/*	ERR_HTMDISABLED      486	   unreal */
-/*      ERR_CHANTOORECENT    487           IRCnet extension (?) */
-/*      ERR_TSLESSCHAN       488           IRCnet extension (?) */
-/*	ERR_VOICENEEDED      489           Undernet extension */
+#define ERR_CANTKICKSERVICES 486
+#define ERR_CANTDEOPSERVICES 487
+/*	ERR_DESYNC	     		484	 		Dalnet,PTlink */
+/*	ERR_ATTACKDENY	     	484	 		unreal */
+/*	ERR_RESTRICTED	     	484	   		IRCnet extension */
+/*  ERR_UNIQOPRIVSNEEDED 	485         IRCnet extension */
+/*	ERR_KILLDENY         	485	   		unreal */
+/*	ERR_CANTKICKADMIN    	485	   		PTlink */
+/*	ERR_HTMDISABLED      	486	   		unreal */
+/*  ERR_CHANTOORECENT    	487         IRCnet extension (?) */
+/*  ERR_TSLESSCHAN       	488         IRCnet extension (?) */
+/*	ERR_VOICENEEDED      	489         Undernet extension */
 #define ERR_NOOPERHOST       491
-/*      ERR_NOSERVICEHOST    492 	   IRCnet extension */
-
+#define ERR_DENIEDFROMCHAN   494
+/*  ERR_NOSERVICEHOST    	492 	   	IRCnet extension */
+#define ERR_SSLACCEPTONLY    498        /* accepting from SSL clients only */
+#define ERR_REGACCEPTONLY    499        /* accepting from reg nicks only */
+#define ERR_TOOMANYWATCH     500
 #define ERR_UMODEUNKNOWNFLAG 501
 #define ERR_USERSDONTMATCH   502
-
 #define ERR_GHOSTEDCLIENT    503
-/*	ERR_VWORLDWARN	     503	   austnet */
-
+/*	ERR_VWORLDWARN	     	503	   		austnet */
 #define ERR_USERNOTONSERV    504
-
 /* #define ERR_LAST_ERR_MSG 505 
  * moved to 999
  */
-
 #define ERR_VCHANDISABLED    506
 #define ERR_ALREADYONVCHAN   507
-
-/*      ERR_NOTIFYFULL       512           aircd */
-/*	ERR_TOOMANYWATCH     512           Numeric List: Dalnet */
-/*      ERR_NEEDPONG	     512           Numeric List: Dalnet */
-
+/*  ERR_NOTIFYFULL       512    aircd */
+/*	ERR_TOOMANYWATCH     512    Numeric List: Dalnet */
+/*  ERR_NEEDPONG	     512    Numeric List: Dalnet */
 #define ERR_WRONGPONG	     513
 /*	ERR_TOOMANYDCC	     514	dalnet */
 /*	ERR_NOINVITE	     518	unreal */
 #define ERR_LONGMASK	     518	/* Undernet extension -Kev */
-/*	ERR_ADMONLY	     519	unreal */
+/*	ERR_ADMONLY	     	 519	unreal */
 /*	ERR_TOOMANYUSERS     519	Undernet extension -Kev */
 /*	ERR_OPERONLY	     520	unreal */
 /*	ERR_MASKTOOWIDE	     520	Undernet extension -Kev */
 /*	ERR_WHOTRUNC	     520	austnet */
 /*	ERR_LASTERROR        521	Undernet extension -Kev */
 /*	ERR_LISTSYNTAX       521	dalnet */
-/*	ERR_WHOSYNTAX	     522        dalnet */
+/*	ERR_WHOSYNTAX	     522    dalnet */
 /*	ERR_WHOLIMEXCEED     523	dalnet */
-
 #define ERR_HELPNOTFOUND     524
-
-/*	RPL_LOGON	     600	dalnet,unreal
+/*	RPL_LOGON	     	 600	dalnet,unreal
 	RPL_LOGOFF           601	dalnet,unreal
 	RPL_WATCHOFF         602	dalnet,unreal
 	RPL_WATCHSTAT        603	dalnet,unreal
@@ -452,36 +422,35 @@
 	RPL_NOWOFF           605	dalnet,unreal
 	RPL_WATCHLIST        606	dalnet,unreal
 	RPL_ENDOFWATCHLIST   607	dalnet,unreal
-
 	RPL_MAPMORE          610	unreal
-
 	RPL_MAPMORE          615	PTlink
-	
 	RPL_DCCSTATUS        617	dalnet
 	RPL_DCCLIST          618	dalnet
 	RPL_ENDOFDCCLIST     619	dalnet
 	RPL_DCCINFO          620	dalnet
-	
-	RPL_DUMPING	     640	unreal
-	RPL_DUMPRPL	     641	unreal
-	RPL_EODUMP	     642	unreal
+	RPL_DUMPING	     	 640	unreal
+	RPL_DUMPRPL	     	 641	unreal
+	RPL_EODUMP	     	 642	unreal
 */
-
+#define RPL_LOGON            600
+#define RPL_LOGOFF           601
+#define RPL_WATCHOFF         602
+#define RPL_WATCHSTAT        603
+#define RPL_NOWON            604
+#define RPL_NOWOFF           605
+#define RPL_WATCHLIST        606
+#define RPL_ENDOFWATCHLIST   607
 #define RPL_MODLIST          702
 #define RPL_ENDOFMODLIST     703
-
 #define RPL_HELPSTART        704
 #define RPL_HELPTXT          705
 #define RPL_ENDOFHELP        706
-
-#define RPL_KNOCK	     710
+#define RPL_KNOCK	     	 710
 #define RPL_KNOCKDLVR	     711
-
 #define ERR_TOOMANYKNOCK     712
 #define ERR_CHANOPEN         713
 #define ERR_KNOCKONCHAN      714
 #define ERR_KNOCKDISABLED    714
-
 #define ERR_LAST_ERR_MSG     999
 
 #endif /* INCLUDED_numeric_h */
diff -uNrd -x CVS ircd-hybrid-7rc5/include/packet.h ircd-hybrid-7-bg/include/packet.h
--- ircd-hybrid-7rc5/include/packet.h	Sat Jul 20 11:51:45 2002
+++ ircd-hybrid-7-bg/include/packet.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: packet.h,v 7.17 2002/07/20 15:51:45 leeh Exp $
+ *  $Id: packet.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef INCLUDED_packet_h
diff -uNrd -x CVS ircd-hybrid-7rc5/include/parse.h ircd-hybrid-7-bg/include/parse.h
--- ircd-hybrid-7rc5/include/parse.h	Thu Jul 11 19:40:17 2002
+++ ircd-hybrid-7-bg/include/parse.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: parse.h,v 7.15 2002/07/11 23:40:17 leeh Exp $
+ *  $Id: parse.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef INCLUDED_parse_h_h
diff -uNrd -x CVS ircd-hybrid-7rc5/include/patchlevel.h ircd-hybrid-7-bg/include/patchlevel.h
--- ircd-hybrid-7rc5/include/patchlevel.h	Thu Oct 31 00:31:37 2002
+++ ircd-hybrid-7-bg/include/patchlevel.h	Sat May 24 23:27:09 2003
@@ -19,9 +19,9 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: patchlevel.h,v 7.39 2002/10/31 05:31:37 lusky Exp $
+ *  $Id: patchlevel.h,v 1.5 2003/05/24 00:07:44 demond Exp $
  */
 
 #ifndef PATCHLEVEL
-#define PATCHLEVEL   "hybrid-7rc5"
+#define PATCHLEVEL   "ircd-hybrid-7-bg-1.4"
 #endif
diff -uNrd -x CVS ircd-hybrid-7rc5/include/res.h ircd-hybrid-7-bg/include/res.h
--- ircd-hybrid-7rc5/include/res.h	Sat Oct 19 18:32:49 2002
+++ ircd-hybrid-7-bg/include/res.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: res.h,v 7.21 2002/10/19 22:32:49 androsyn Exp $
+ *  $Id: res.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef _RES_H_INCLUDED
diff -uNrd -x CVS ircd-hybrid-7rc5/include/restart.h ircd-hybrid-7-bg/include/restart.h
--- ircd-hybrid-7rc5/include/restart.h	Sat Jan  5 04:14:29 2002
+++ ircd-hybrid-7-bg/include/restart.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: restart.h,v 7.4 2002/01/05 09:14:29 a1kmm Exp $
+ *  $Id: restart.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef INCLUDED_restart_h
diff -uNrd -x CVS ircd-hybrid-7rc5/include/resv.h ircd-hybrid-7-bg/include/resv.h
--- ircd-hybrid-7rc5/include/resv.h	Fri May 24 19:34:08 2002
+++ ircd-hybrid-7-bg/include/resv.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: resv.h,v 1.7 2002/05/24 23:34:08 androsyn Exp $
+ *  $Id: resv.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef INCLUDED_resv_h
diff -uNrd -x CVS ircd-hybrid-7rc5/include/rsa.h ircd-hybrid-7-bg/include/rsa.h
--- ircd-hybrid-7rc5/include/rsa.h	Thu Jul 11 05:23:19 2002
+++ ircd-hybrid-7-bg/include/rsa.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: rsa.h,v 7.11 2002/07/11 09:23:19 androsyn Exp $
+ *  $Id: rsa.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 #ifndef INCLUDED_rsa_h
 #define INCLUDED_rsa_h 1
diff -uNrd -x CVS ircd-hybrid-7rc5/include/s_auth.h ircd-hybrid-7-bg/include/s_auth.h
--- ircd-hybrid-7rc5/include/s_auth.h	Sat Oct 19 18:32:49 2002
+++ ircd-hybrid-7-bg/include/s_auth.h	Mon Dec 30 23:07:25 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_auth.h,v 7.17 2002/10/19 22:32:49 androsyn Exp $
+ *  $Id: s_auth.h,v 1.1.1.1 2002/12/31 04:07:25 demond Exp $
  */
 
 #ifndef INCLUDED_s_auth_h
diff -uNrd -x CVS ircd-hybrid-7rc5/include/s_bsd.h ircd-hybrid-7-bg/include/s_bsd.h
--- ircd-hybrid-7rc5/include/s_bsd.h	Fri May 24 19:34:08 2002
+++ ircd-hybrid-7-bg/include/s_bsd.h	Thu Jan 30 10:28:59 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_bsd.h,v 7.36 2002/05/24 23:34:08 androsyn Exp $
+ *  $Id: s_bsd.h,v 1.2 2003/01/30 15:28:59 demond Exp $
  */
 
 #ifndef INCLUDED_s_bsd_h
@@ -71,7 +71,7 @@
 extern const char * comm_errstr(int status);
 extern int   comm_open(int family, int sock_type, int proto,
                  const char *note);
-extern int   comm_accept(int fd, struct irc_sockaddr *pn);
+extern int   comm_accept(int fd, struct irc_sockaddr *pn, int is_ssl);
 
 /* These must be defined in the network IO loop code of your choice */
 extern void  comm_setselect(int fd, fdlist_t list, unsigned int type,
diff -uNrd -x CVS ircd-hybrid-7rc5/include/s_conf.h ircd-hybrid-7-bg/include/s_conf.h
--- ircd-hybrid-7rc5/include/s_conf.h	Wed Oct 30 12:44:53 2002
+++ ircd-hybrid-7-bg/include/s_conf.h	Sat May 24 23:27:09 2003
@@ -19,15 +19,13 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: s_conf.h,v 7.188 2002/10/30 17:44:53 wiz Exp $
+ *  $Id: s_conf.h,v 1.4 2003/05/24 00:07:44 demond Exp $
  */
 
 #ifndef INCLUDED_s_conf_h
 #define INCLUDED_s_conf_h
 #include "setup.h"
 
-
-
 #ifdef HAVE_LIBCRYPTO
 #include <openssl/rsa.h>
 #endif
@@ -99,6 +97,7 @@
 #define CONF_XLINE             0x40000
 #define CONF_ULINE             0x80000
 #define CONF_EXEMPTDLINE      0x100000
+#define CONF_ZLINE            0x200000
 
 #define CONF_SERVER_MASK       CONF_SERVER
 #define CONF_CLIENT_MASK       (CONF_CLIENT | CONF_OPERATOR | CONF_SERVER_MASK)
@@ -131,8 +130,11 @@
 #define CONF_FLAGS_COMPRESSED           0x00020000
 #define CONF_FLAGS_TEMPORARY            0x00040000
 #define CONF_FLAGS_CRYPTLINK            0x00080000
-/* Macros for struct ConfItem */
+/* additional client flag */
+#define CONF_FLAGS_MASKHOST             0x00100000
+#define CONF_FLAGS_SKIPFAIL             0x00200000
 
+/* Macros for struct ConfItem */
 #define IsLimitIp(x)            ((x)->flags & CONF_FLAGS_LIMIT_IP)
 #define IsNoTilde(x)            ((x)->flags & CONF_FLAGS_NO_TILDE)
 #define IsConfCanFlood(x)       ((x)->flags & CONF_FLAGS_CAN_FLOOD)
@@ -151,9 +153,10 @@
 #define IsConfEncrypted(x)      ((x)->flags & CONF_FLAGS_ENCRYPTED)
 #define IsConfCompressed(x)     ((x)->flags & CONF_FLAGS_COMPRESSED)
 #define IsConfCryptLink(x)      ((x)->flags & CONF_FLAGS_CRYPTLINK)
+#define IsConfMaskHost(x)       ((x)->flags & CONF_FLAGS_MASKHOST)
+#define IsConfSkipOnPassFail(x) ((x)->flags & CONF_FLAGS_SKIPFAIL)
 
 /* port definitions for Opers */
-
 #define CONF_OPER_GLOBAL_KILL   0x0001
 #define CONF_OPER_REMOTE        0x0002
 #define CONF_OPER_UNKLINE       0x0004
@@ -164,6 +167,10 @@
 #define CONF_OPER_DIE           0x0080
 #define CONF_OPER_ADMIN         0x0100
 
+#define MAXNETID 	6
+#define MAXDREASON 120
+#define REPGRACEDEF 20
+
 struct config_file_entry
 {
   char *dpath;          /* DPATH if set from command line */
@@ -187,13 +194,17 @@
   char fname_userlog[MAXPATHLEN];
   char fname_foperlog[MAXPATHLEN];
 
+  char netid[MAXNETID + 1];
+  char drone_reason[MAXDREASON + 1];
+  char spawn_pass[PASSWDLEN + 1];
+
   MessageFile motd;
   MessageFile opermotd;
   MessageFile linksfile;
 
   int           hub;
   unsigned char compression_level;
-  int		dot_in_ip6_addr;
+  int			dot_in_ip6_addr;
   int           dots_in_ident;
   int           failed_oper_notice;
   int           anti_nick_flood;
@@ -208,9 +219,9 @@
   int           warn_no_nline;
   int           non_redundant_klines;
   int           stats_o_oper_only;
-  int		stats_k_oper_only;
-  int		stats_i_oper_only;
-  int		stats_P_oper_only;
+  int			stats_k_oper_only;
+  int			stats_i_oper_only;
+  int			stats_P_oper_only;
   int           pace_wait;
   int           pace_wait_simple;
   int           short_motd;
@@ -232,8 +243,21 @@
   /* 0 == don't use throttle... */
   int           throttle_time;
   int           use_egd;
-  int		ping_cookie;
+  int			ping_cookie;
   int           use_help;
+
+  int         cyrillic;
+  int         totaltrans;
+  int		  grace_time;
+  int         spam_wait;
+  int         repeat_grace;
+  int         drone_kline;
+  int         drone_batch;
+  int         drone_rate_max;
+  int         drone_rate_period;
+  int         drone_kline_time;
+
+  long		sframe;
 #ifdef IPV6  
   int		fallback_to_ip6_int;
 #endif
@@ -250,6 +274,8 @@
   int   use_invex;
   int   use_knock;
   int   use_vchans;
+  int	use_subst;
+  int	use_denies;
   int   knock_delay;
   int	knock_delay_channel;
   int   vchans_oper_only;
@@ -284,8 +310,12 @@
 #ifdef HAVE_LIBCRYPTO
   char *      rsa_private_key_file;
   RSA *       rsa_private_key;
+  char *      ssl_certificate_file;
+  SSL_CTX *   ctx;
+  SSL_METHOD *meth;
 #endif
   int         hub;
+  int         gateway;
   struct      irc_inaddr ip;
   struct      irc_inaddr ip6;
   int         max_clients;
@@ -421,6 +451,23 @@
 #define TOO_FAST        (-6)
 
 #define CLEANUP_TKLINES_TIME 60
+
+extern int find_z_conf(char *);
+extern void report_zlines(struct Client* client_p);
+extern void report_equivs(struct Client* client_p);
+extern void add_equiv_nicks(char *);
+extern char *get_equiv_nick(char *, char *);
+extern void add_userpar_param(char *);
+extern void report_userparms(struct Client *);
+extern int IsUserPar(char *, char *);
+extern void add_relay_server(char *);
+extern void report_relays(struct Client *);
+extern int IsRelay(struct Client *);
+extern void add_cluster_bridge(char *);
+extern void report_clusters(struct Client *);
+extern char *get_bridge_token(struct Client *);
+extern int HasBridgeToken(char *);
+extern void conf_add_z_conf(struct ConfItem *);
 
 #endif /* INCLUDED_s_conf_h */
 
